System.Gadget.settingsUI = "cgsettings.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.onUndock = checkState;
System.Gadget.onDock = checkState;

var gadgetpath = System.Gadget.path;
var inputFile = gadgetpath + "\\input.txt";
var dataFile = gadgetpath + "\\data.txt";
var mainPage = "http://coinmarketcap.com/";
var readPage = "http://coinmarketcap.com/currencies/views/all/";
var linkPage = "http://coinmarketcap.com/currencies/";
var count = 0;
var state = 1;
var refreshInt = "10";
var setCurr = "usd";
var currs;
var data;
var indstartdata = 2;
var sets;

if (System.Gadget.Settings.read("RefreshInterval") != "" && 
    System.Gadget.Settings.read("Currencies") != "" &&
    System.Gadget.Settings.read("SetCurrency") != "") 
{
    refreshInt = System.Gadget.Settings.readString("RefreshInterval");
    currs = System.Gadget.Settings.readString("Currencies");
    setCurr = System.Gadget.Settings.readString("SetCurrency");
}

function checkState()
{
	if (System.Gadget.docked)
	{
		smallerSize();
	}
	else
	{
		largerSize();
	}
}

function smallerSize(){
  with (document.body.style)
	{
		width = "150px";    
	}
  var body = document.getElementsByTagName('body')[0];
  body.style.backgroundImage = 'url(../images/back150.png)';
  
  reloadPage();  
}

function largerSize() {
  with (document.body.style)
	{
		width = "225px";
	}
  var body = document.getElementsByTagName('body')[0];
  body.style.backgroundImage = 'url(../images/back225.png)';
  
  reloadPage();  
}

function init() {
  fillSets();
  
  if (System.Gadget.Settings.read("RefreshInterval") == "" || 
      System.Gadget.Settings.read("Currencies") == "" ||
      System.Gadget.Settings.read("SetCurrency") == "") 
  {
    System.Gadget.Settings.writeString("RefreshInterval", sets[0][0]);
    refreshInt = sets[0][0];
    
    System.Gadget.Settings.writeString("SetCurrency", sets[1][0]);
    setCurr = sets[1][0];
    
    currs = getCurrText();
    System.Gadget.Settings.writeString("Currencies", currs);
  }
  
  getData();
  setInterval(function () { updateTick(); }, 60000);
}

function getData() {
  try
  { 
    var result = httpGet(readPage);
    var sourceCurr = getSourceCurr();
    
    if (result != "")
    {
      var first = cutStart(result, "tbody");
      var firstr = cutEnd(first, "/tbody");
      var res = firstr.split("</tr>");
      
      data = [];
      data = new Array(res.length - 1);
      for (var i = 0; i < res.length - 1; i++) {
        data[i] = new Array(4);
      }
      
      for (var i = 0; i < res.length - 1; i++) {
        // id
        var t1 = cutStart(res[i], "id=\"");
        var t2 = cutEnd(t1, "\"");
        var t2r = cutStart(t2, "id-");
        
        if (t2r != "")
        {
          // image
          var t1b = cutStart(res[i], "img src=\"");
          var t2b = cutEnd(t1b, "\"");
          data[i][0] = mainPage + t2b;
          
          // symbol
          var t3 = cutStart(t1b, "class=\"text-left\">");
          var t4 = cutEnd(t3, "</");
          var t4r = t4.replace(/\s+/g,"");
          data[i][1] = t4r;
          
          // convert rate
          var t5 = cutStart(t1b, "class=\"price\"");
          var t6 = cutStart(t5, sourceCurr);
          var t7 = cutEnd(t6, "\"");
          data[i][2] = t7;
          
          // market cap link
          data[i][3] = linkPage + t2r;
          
        }
        else
          break;      
      }
      
      state = 1;
      
      var fs = new ActiveXObject("Scripting.FileSystemObject");
    	var newFile = fs.CreateTextFile(inputFile);
    	try
    	{
        for (var i = 0; i < data.length; i++) {
    		  newFile.WriteLine(data[i][0] + ";" + data[i][1] + ";"
            + data[i][2] + ";" + data[i][3]);
        }
    	}
    	finally
    	{
    		newFile.Close();
    	}
    }
    else
    {
      fillInput(); 
    }
  }
  catch(e)
  {
    fillInput();    
  }
  
  reloadPage();  
}

function reloadPage() {
  var totalFunds = 0;
  var countCurr = 0;
  var currsym = getCurrSymbol();
  
  for (var i = sets.length - 1; i >= indstartdata; i--) {
    for (var j = 0; j < data.length; j++)
    {
      if (sets[i][0].toUpperCase() == data[j][1].toUpperCase())
      {
        countCurr++;
      
        if (data[j][2] != "" && data[j][2] != "?" && sets[i][1] != "")
        {
          totalFunds = totalFunds 
            + (parseFloat(data[j][2]))*(parseFloat(sets[i][1]));
        }      
      }
    }
  }

  if (System.Gadget.docked)
	{
    var height = 22 * countCurr + 36;
    document.getElementById("main").style.height = height.toString() + "px";
  }
  else
  {
    var height = 30 * countCurr + 48;
    document.getElementById("main").style.height = height.toString() + "px";  
  } 

  var intFunds = 0;
  if (setCurr != "btc")
  {
    intFunds = Math.round(totalFunds);  
  }
  else
  {
    var mathr = Math.round(totalFunds);
  
    if (mathr < 10)
    {
      intFunds = Math.round(totalFunds*1000)/1000;
    }
    else if (mathr < 100)
    {
      intFunds = Math.round(totalFunds*100)/100;  
    }
    else if (mathr < 1000)
    {
      intFunds = Math.round(totalFunds*10)/10;  
    }
    else
    {
      intFunds = Math.round(totalFunds);  
    }  
  }
  
  var table = document.getElementById("table");
  for(var i = table.rows.length - 1; i >= 0; i--)
  {
      table.deleteRow(i);
  }
  
  var row = table.insertRow(0);
  var cell0 = row.insertCell(0);
  var cell1 = row.insertCell(1);
  var cell2 = row.insertCell(2);
  
  if (System.Gadget.docked) {
  
    if (state == 1) {
      cell0.innerHTML = "<div style=\"height: 32px;\"><img "
        + "src=\"images/online.png\" alt=\"Online\" style="
        + "\"margin-top: 15px; margin-left: 6px;\" /></div>";
    }
    else {
      cell0.innerHTML = "<div style=\"height: 32px;\"><img "
        + "src=\"images/offline.png\" alt=\"Connection problem!\" style="
        + "\"margin-top: 10px; margin-left: 2px;\" /></div>";  
    }
    
    cell1.innerHTML = "<div style=\"font-size: 9px;\">TOTAL "
      + currsym + ":</div>";
    cell2.innerHTML = intFunds.toString();
  }
  else {
    
    if (state == 1) {
      cell0.innerHTML = "<div style=\"height: 48px;\"><img "
        + "src=\"images/online.png\" alt=\"Online\" style="
        + "\"margin-top: 24px; margin-left: 12px;\" /></div>";
    }
    else {
      cell0.innerHTML = "<div style=\"height: 48px;\"><img "
        + "src=\"images/offline.png\" alt=\"Connection problem!\" style="
        + "\"margin-top: 20px; margin-left: 8px;\" /></div>";  
    }
    
    cell1.innerHTML = "<div style=\"font-size: 14px;\">TOTAL "
      + currsym + ":</div>";
    cell2.innerHTML = "<div style=\"font-size: 16px; margin-top: 2px;\">"
      + intFunds.toString() + "</div>";  
  }
  
  for (var i = sets.length - 1; i >= indstartdata; i--) {
    for (var j = 0; j < data.length; j++)
    {
      if (sets[i][0].toUpperCase() == data[j][1].toUpperCase())
      {
        var row = table.insertRow(0);
        var cell0 = row.insertCell(0);
        var cell1 = row.insertCell(1);
        var cell2 = row.insertCell(2);
        
        if (System.Gadget.docked)
	      {
          cell0.innerHTML = "<img src=\"" + data[j][0] 
            + "\" alt=\"" + data[j][1] + "\" />&nbsp";
          
          if (data[j][2].toString().length <= 6)
          {  
            cell1.innerHTML = "<a href=\"" + data[j][3] 
              + "\" style=\"width: 55px;\">" + data[j][2] 
              + currsym + "</a>";
          }
          else
          {
            if (setCurr != "btc")
            {
              var price = convertCurrFormat(data[j][2]);
              cell1.innerHTML = "<a href=\"" + data[j][3] 
                + "\" style=\"width: 55px;\">" + price + currsym + "</a>";
            }
            else
            {
              var price = convertBTCformat(data[j][2]);
              cell1.innerHTML = "<a href=\"" + data[j][3] 
                + "\" style=\"width: 55px;\">" + price + "</a>";  
            }  
          }
            
          cell2.innerHTML = "<input id=\"" + data[j][1].toLowerCase()
            + "\" class=\"inputsmall\" type=\"text\" value=\"" + sets[i][1]
            + "\" onchange=\"changedInput()\" />";
        }
        else {
          cell0.innerHTML = "<img src=\"" + data[j][0] + "\" alt=\"" 
            + data[j][1] + "\" style=\"width: 24px; height: 24px; "
            + "margin-left: 2px;\"/>&nbsp";
          
          if (data[j][2].toString().length <= 6)
          {  
            cell1.innerHTML = "<a href=\"" + data[j][3] 
              + "\" style=\"width: 85px; font-size: 16px;\">" + data[j][2]
              + currsym + "</a>";
          }
          else
          {
            if (setCurr != "btc")
            {
              var price = convertCurrFormat(data[j][2]);
              cell1.innerHTML = "<a href=\"" + data[j][3] 
                + "\" style=\"width: 85px; font-size: 16px;\">" + price
                + currsym + "</a>";
            }
            else
            {
              var price = convertBTCformat(data[j][2]);
              cell1.innerHTML = "<a href=\"" + data[j][3] 
                + "\" style=\"width: 85px; font-size: 16px;\">" 
                + price + "</a>";  
            }  
          }
            
          cell2.innerHTML = "<input id=\"" + data[j][1].toLowerCase()
            + "\" class=\"inputlarge\" type=\"text\" value=\"" + sets[i][1]
            + "\" onchange=\"changedInput()\" />";  
        } 
      }              
    }  
  }
}

function changedInput()
{
  for(var i = indstartdata; i < sets.length; i++)
  {
    var element = document.getElementById(sets[i][0].toLowerCase());
    if (parseFloat(element.value).toString() != "NaN") {
      sets[i][1] = element.value;
    }
    else {
      sets[i][1] = 0;  
    }    
  }
  
  saveToFile(sets);
  reloadPage();
}

function fillInput()
{
  state = 0;

  var fi = new ActiveXObject("Scripting.FileSystemObject");
  var file = fi.GetFile(inputFile);
  var allData = file.OpenAsTextStream(1);
  var lineCount = 0;
  
  while (!allData.AtEndOfStream)
  {
    var line = allData.ReadLine();
    lineCount++;
  }
  
  data = [];
  data = new Array(lineCount);
  for (var i = 0; i < lineCount; i++) {
    data[i] = new Array(4);
  }
  
  var inData = file.OpenAsTextStream(1);
  var lc = 0;
  while (!inData.AtEndOfStream)
  {
    var line = inData.ReadLine();
    data[lc] = line.split(";");
    lc++;
  }  
}

function fillSets()
{
  var fs = new ActiveXObject("Scripting.FileSystemObject");
  var fileSet = fs.GetFile(dataFile);
  var setsData = fileSet.OpenAsTextStream(1);
  var lineCount = 0;
  
  while (!setsData.AtEndOfStream)
  {
    var line = setsData.ReadLine();
    lineCount++;
  }
  
  sets = [];
  sets = new Array(lineCount);
  for (var i = 0; i < lineCount; i++) {
    sets[i] = new Array(2);
  }
  
  var sData = fileSet.OpenAsTextStream(1);
  var lc = 0;
  while (!sData.AtEndOfStream)
  {
    var line = sData.ReadLine();
    sets[lc] = line.split(";");
    lc++;
  }  
}

function getCurrText()
{
  var result = "";
   
  for (var i = 2; i < sets.length; i++) {
    result += sets[i][0] + ";";
  }
  
  return result;  
}

function getSourceCurr()
{
  switch(setCurr)
  {
    case "usd": return "data-usd=\"";
    case "btc": return "data-btc=\"";
    /*case "eur": return "data-eur=\"";
    case "gbp": return "data-gbp=\"";
    case "cny": return "data-cny=\"";
    case "rub": return "data-rub=\"";
    case "cad": return "data-cad=\"";
    case "hkd": return "data-hkd=\"";*/
    default: return "data-usd=\"";
  }
}

function getCurrSymbol()
{
  switch(setCurr)
  {
    case "usd": return "$";
    case "btc": return "&#3647";
    /*case "eur": return "&#8364";
    case "gbp": return "&#163";
    case "cny": return "&#165";
    case "rub": return "P";
    case "cad": return "$";
    case "hkd": return "$";*/
    default: return "$";
  }
}

function convertCurrFormat(textfloat)
{
  var prc = parseFloat(textfloat);
  
  if (prc < 0.0001)
  {
    return prc.toExponential(1);
  }
  else
  {
    if (prc < 10)
    {
      var retres = Math.round(prc*10000)/10000;
      return retres; 
    }
    else if (prc < 100)
    {
      var retres = Math.round(prc*1000)/1000;
      return retres; 
    }
    else if (prc < 1000)
    {
      var retres = Math.round(prc*100)/100;
      return retres; 
    }
    else if (prc < 10000)
    {
      var retres = Math.round(prc*10)/10;
      return retres; 
    }
    else
    {
      var retres = Math.round(prc);
      return retres; 
    }  
  } 
}

function convertBTCformat(textfloat)
{
  var prc = parseFloat(textfloat);
  
  if (prc < 0.0001)
  {
    var retres = Math.round(prc*1000000000)/10;
    return retres + "S";
  }
  else
  {
    if (prc < 10)
    {
      var retres = Math.round(prc*10000)/10000;
      return retres + "&#3647"; 
    }
    else if (prc < 100)
    {
      var retres = Math.round(prc*1000)/1000;
      return retres + "&#3647"; 
    }
    else if (prc < 1000)
    {
      var retres = Math.round(prc*100)/100;
      return retres + "&#3647"; 
    }
    else if (prc < 10000)
    {
      var retres = Math.round(prc*10)/10;
      return retres + "&#3647"; 
    }
    else
    {
      var retres = Math.round(prc);
      return retres + "&#3647"; 
    }  
  } 
}

function httpGet(theUrl)
{
    var xmlHttp = null;
    xmlHttp = new XMLHttpRequest();
    xmlHttp.open("GET", theUrl + "?r=" + makeId(), false);
    xmlHttp.send(null);
    return xmlHttp.responseText;
}

function makeId()
{
    var text = "";
    var poss = "abcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < 16; i++ )
        text += poss.charAt(Math.floor(Math.random() * poss.length));

    return text;
}

function updateTick() {
    count++;
    
    if (count >= parseInt(refreshInt)) {
        getData();
        count = 0;
    }
}

function SettingsClosed(event) {
  if (event.closeAction == event.Action.commit) {
      refreshInt = System.Gadget.Settings.readString("RefreshInterval");
      setCurr = System.Gadget.Settings.readString("SetCurrency");
      currs = System.Gadget.Settings.readString("Currencies");
      
      try
      {
        var test = parseInt(refreshInt);
        if (test < 2) 
        {
          refreshInt = "2";
          System.Gadget.Settings.writeString("RefreshInterval", refreshInt);
        }    
      }
      catch(e)
      {
        refreshInt = "10";
        System.Gadget.Settings.writeString("RefreshInterval", refreshInt);  
      }
      
      saveNewSettings();
      fillSets();
      getData();
  }
  event.cancel = false;
}

function saveNewSettings()
{
  var newCurrs = currs.split(";");
  var size = 0;
  var ok = false;
  
  for(var i = 0; i < newCurrs.length; i++)
  {
    ok = false;
    for(var j = indstartdata; j < sets.length; j++)
    {
      if (newCurrs[i] == sets[j][0])
      {
        size++;
        ok = true;  
      }
    }
    
    if(!ok)
    {
      for(var j = 0; j < data.length; j++)
      {
        if (newCurrs[i] == data[j][1])
        {
          size++;  
        }
      }  
    }
  }
  
  if (size == 0) {
    size = 1;
  }
  
  var newSets = new Array(size + indstartdata);
  for (var i = 0; i < size + indstartdata; i++) {
    newSets[i] = new Array(2);
  }
  
  newSets[0][0] = refreshInt;
  newSets[1][0] = setCurr;
  size = indstartdata;
  for(var i = 0; i < newCurrs.length; i++)
  {
    ok = false;
    for(var j = indstartdata; j < sets.length; j++)
    {
      if (newCurrs[i] == sets[j][0])
      {
        newSets[size][0] = sets[j][0];
        newSets[size][1] = sets[j][1];
        size++;
        ok = true;  
      }
    }
    
    if(!ok)
    {
      for(var j = 0; j < data.length; j++)
      {
        if (newCurrs[i] == data[j][1])
        {
          newSets[size][0] = data[j][1];
          newSets[size][1] = "0";
          size++;  
        }
      }  
    }
  }
  
  if (size == indstartdata) {
    newSets[indstartdata][0] = "BTC";
    newSets[indstartdata][1] = "0";
  }

  saveToFile(newSets);    
}

function saveToFile(arraySets)
{
  var fd = new ActiveXObject("Scripting.FileSystemObject");
	var newFile = fd.CreateTextFile(dataFile);
	try
	{
    for (var i = 0; i < indstartdata; i++) {
      newFile.WriteLine(arraySets[i][0]);
    }
    for (var i = indstartdata; i < arraySets.length; i++) {
		  newFile.WriteLine(arraySets[i][0] + ";" + arraySets[i][1]);
    }
	}
	finally
	{
		newFile.Close();
	}  
}

function getElementsByClassName(node, classname) {
    var a = [];
    var re = new RegExp('(^| )'+classname+'( |$)');
    var els = node.getElementsByTagName("*");
    for(var i=0,j=els.length; i<j; i++) {
        if(re.test(els[i].className)) {
        a.push(els[i]);
        }
    }
    return a;
}

function cut(str, startString, endString){
  var cutStart = str.indexOf(startString) + startString.length;
  var cutEnd = str.indexOf(endString);
  return str.substr(cutStart, cutEnd - cutStart);
}

function cutStart(str, startString){
  var cutStart = str.indexOf(startString) + startString.length;
  return str.substr(cutStart);
}

function cutEnd(str, endString){
  var cutEnd = str.indexOf(endString);
  return str.substr(0, cutEnd);
}
